//
//  ViewController.swift
//  TableViewPrefetch
//
//  Created by Hoh Shi Chao on 31/10/21.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var console: UITextView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        console.layoutManager.allowsNonContiguousLayout = false
    }

    private func log(text: String) {
        console.text.append("\n" + text)
        let range = NSRange(location: console.text.count - 1, length: 0)
        console.scrollRangeToVisible(range)
    }
}

extension ViewController: UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 100
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        log(text: "cellForRowAt index row: \(indexPath.row)")
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "PrefetchTableViewCell", for: indexPath) as! PrefetchTableViewCell
        
        cell.leftLabel.text = "\(indexPath.row)"
        
        if indexPath.row == 0 {
            // Let's modify the label text label if this is the firstmost row.
            cell.rightLabel.text = "This is only shown for index 0."
        }/* else { // uncomment this to fix the bug
            cell.rightLabel.text = ""
        }*/
        
        console.text.append("")
        
        return cell
    }
    
}

extension ViewController: UITableViewDelegate {
    func tableView(_ tableView: UITableView, didEndDisplaying cell: UITableViewCell, forRowAt indexPath: IndexPath) {
        log(text: "didEndDisplaying index row: \(indexPath.row)")
        
        if let cell = cell as? PrefetchTableViewCell {
//            cell.rightLabel.text = "" // Uncomment this can also fix the bug as well.
            cell.leftLabel.text = ""
        }
        
    }
}
